/*

*/

import java.lang.*;
import java.io.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Date;
import java.text.DecimalFormat;
//##########################
class computeAvgF
{ 
    private basicConcepts bc;
    
    private String dd1, dd2, dd3;
    private DecimalFormat dformat, dformat2;
    
    private double[] countOri, countExt, countCor;    
    
    private int ii, jj, kk, nn, iii;
    private double dtmp1, dtmp2, dtmp3;
    private String line, argTrainingDirName, argAbsDirName;
    private String tmp1, tmp2, tmp3, tmp4, tmp5;
    private File F1,F2, F3, F4, F5, F6, F7, F8;
    private RandomAccessFile file1,file2, file3, file4, file5, file6, file7, file8;
    
    //####################
    public computeAvgF(String arg)
    {
	argTrainingDirName = arg;
	bc = new basicConcepts();
	
	dformat = new DecimalFormat("#.##");
	dformat2  = new DecimalFormat("#.####");
		
	countOri = new double[bc.C_SIZE]; countExt = new double[bc.C_SIZE]; 
	countCor = new double[bc.C_SIZE];
	
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    countOri[iii] = countExt[iii] = countCor[iii] = 0;
	}
    }
    //########
    private void runTenFolder() 
    {
	try {
	    F1 = new File(".",argTrainingDirName+"/"+argTrainingDirName+"_nbc_statistics_token_all");
	    file1 = new RandomAccessFile(F1, "r");
	    
	    while ((line=file1.readLine())!=null) {
		if (line.startsWith("<") && line.indexOf("> recall=")==3) {
		    line = line.trim();
		    tmp1 = line.substring(0,4);// <tag>
		    if (!bc.tagHash.containsKey(tmp1)) {continue;}
		    ii = Integer.parseInt(String.valueOf(bc.tagHash.get(tmp1))); //<tag> id
		    if (tmp1.equals("<AW>") || tmp1.equals("<ED>") || tmp1.equals("<RS>") || tmp1.equals("<RE>")){ //|| tmp1.equals("<DE>")) {
			countOri[ii] = 0; countExt[ii] = 0;
			continue;
		    }
		    
		    jj = line.indexOf("recall="); //recall=1.0/2.0=
		    line = line.substring(jj+7); //1.0/2.0=
		    kk = line.indexOf("/");
		    jj = line.indexOf("=");
		    countOri[ii] += Double.parseDouble(line.substring(kk+1,jj));
		    
		    jj = line.indexOf("fScore="); //fScore=23.45
		    line = line.substring(jj+7); //1.0/2.0=
		    jj = line.indexOf("=");
		    countExt[ii] += Double.parseDouble(line.substring(jj+1).trim());
		}//if
	    }//while
	    file1.close();
	}
	catch (java.lang.Exception e) {System.out.println("@.."+e.toString());}
	
	dtmp1 = 0; dtmp2 = 0;
	for(ii=0;ii<bc.csTag.length;ii++) {
	    dtmp1 += countOri[ii] * countExt[ii];
	    dtmp2 += countOri[ii];
	    System.out.println(bc.csTag[ii]+" "+countOri[ii]+" "+countExt[ii]);
	}
	System.out.println("-----------\n"+dformat2.format(dtmp1/dtmp2*100));
	
	return;
    }
//####################
    public static void main(String[] args)
    {
    	computeAvgF gf = new computeAvgF(args[0]);//Dir name where the addTail files are
	gf.runTenFolder();
	
	return;
    }
}
