import java.lang.*;
import java.io.*;
import java.util.*;
//############################################################
/*
  get a directory path, find all files from it and all the sub-dirs
  
  filesFromDir fdd = new filesFromDir(dirName, fileExtFilter) 
  fdd.findFiles();
  if (fdd.fileList.size()>0) {
      for(ii=0;ii<fdd.fileList.size();ii++) {
          fileName = String.valueOf(fdd.fileList.elementAt(ii));
	  ...
      }
  }
*/

class filesFromDir
{
    File currentDir;
    public Vector fileList;
    Vector dirList;
    File[] tempList;
    int tt;
    String tmp, filter;

    public filesFromDir() {//absolute path, filter=.*
	fileList = new Vector();
	dirList = new Vector();
    }

    public void set(String arg1, String arg2) {//absolute path, filter
	fileList.clear();
	dirList.clear();
	dirList.add(arg1);
	filter = arg2;
	return;
    }
    
    public boolean findFiles() {
	fileList.clear();
	
	while (dirList.size()>0) {
	    currentDir = new File(String.valueOf(dirList.elementAt(0)));
	    dirList.remove(0);
	
	    tempList = currentDir.listFiles();
	    if (tempList.length>0) {
		for(tt=0;tt<tempList.length;tt++) {
		    
		    if (tempList[tt].isDirectory()) {dirList.add(tempList[tt].getAbsolutePath());}
		    else if (tempList[tt].isFile()) {
			tmp = tempList[tt].getAbsolutePath();
			if (filter.equals(".*") || tmp.endsWith(filter)) {fileList.add(tmp);}
		    }
		}//for tt
	    }//if templist>0
	}//while
	System.out.println(fileList.size()+" files found");
	if (fileList.size()>0) {return true;}
	else {return false;}
    }    

    public static void main(String args[]) {
	filesFromDir fdd = new filesFromDir();
	
	if (args.length==1) {fdd.set(args[0],".*");}
	else if (args.length==2) {fdd.set(args[0], args[1]);}
	else {return;}
	
	if (fdd.findFiles()) {
	    for(int xxx=0;xxx<fdd.fileList.size();xxx++) {
		System.out.println(String.valueOf(fdd.fileList.elementAt(xxx)));
	    }
	}
	return;
    }
}
