/*
train the relative position feature
*/

import java.lang.*;
import java.io.*;
import java.util.Vector;
import java.util.Date;
import java.text.DecimalFormat;
//##########################
class segTestOneCmmcTrain3
{ 
    private basicConcepts bc;
    private double dtmp1;
    private int[] countC;
    private int[][] cPosC, wPosC;
    private int[] recCount;
    private String[] words1, dataStr, fileNames, dataL,  answerL;
    private int iii,jjj,fff,ggg, bbb, C_INDEX, cLen, wLen;
    private int ii, zz, STARTSET, ENDSET, POSRANGE=10;
    private String line, argTrainingDirName, argAbsDirName, fileStr1;
    private String trainStr, tmp1, tmp2, tmp3;
    private File F1,F2, F3;
    private RandomAccessFile file1,file2, file3;
    private boolean found1;
    private Vector seg0;
    private Date sDate, eDate;
    private filesFromDir ffd;
    //###############
    public segTestOneCmmcTrain3(String arg, String argStartID, String argEndID)
    {
	argTrainingDirName = arg;
	bc = new basicConcepts();
		
	try {STARTSET = Integer.parseInt(argStartID); ENDSET = Integer.parseInt(argEndID);}
	catch  (java.lang.Exception e) {System.out.println(e.toString()+"..startsetid"); STARTSET=0; ENDSET = 0;}
	//-------------------
	countC = new int[bc.C_SIZE];
	wPosC = new int[bc.C_SIZE][POSRANGE];
	cPosC = new int[bc.C_SIZE][POSRANGE];
	seg0 = new Vector();
    }
    //####################
    private void runTenFolder() 
    {
	int runff,rungg, uuu;
	sDate = new java.util.Date();
	System.out.println("1");
	try {
	    ffd = new filesFromDir();
	    ffd.set(argTrainingDirName,"_addTail");
	    System.out.println("2");
	    
	    if (ffd.findFiles() && ffd.fileList.size()>0) {
		System.out.println("2.5");
		STARTSET = 0; ENDSET = ffd.fileList.size();
		System.out.println("3");
		F1 = new File(String.valueOf(ffd.fileList.elementAt(0)));
		argAbsDirName = F1.getPath();
		argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("/"));
		
		//argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("\\"));
		
		dataStr = new String[ffd.fileList.size()];
		recCount = new int[ffd.fileList.size()];
		fileNames = new String[ffd.fileList.size()];
		System.out.println("4");
		for(runff=0;runff<ffd.fileList.size();runff++) {
		    F1 = new File(String.valueOf(ffd.fileList.elementAt(runff)));
		    file1 = new RandomAccessFile(F1,"r");
		    		    
		    fileNames[runff] = F1.getPath();
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("/")+1);
		    //fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("\\")+1);
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].indexOf("clean_")+6, fileNames[runff].indexOf("_labeled"));
		    recCount[runff] = 0; //# of rec <REC>
		    dataStr[runff] = "";
		    while ((line=file1.readLine())!=null) {
			if (!line.startsWith("<")) {continue;}
			dataStr[runff] += line.trim();
			if (line.equals("<REC>")) {recCount[runff]++;}
		    }
		    file1.close();
		    System.out.println(recCount[runff] +" Records in " + fileNames[runff]);
		}//for runff
	    } //if ffd
	    else {dataStr = null;System.out.println("5");}
	}
	catch (java.lang.Exception e) {System.out.println(e.toString());}
	
	//for(runff=STARTSET;runff<ffd.fileList.size();runff++) {System.out.println(dataStr[runff].length());}

	for(runff=STARTSET;runff<ENDSET;runff++) { 
	    trainStr = ""; uuu = 0;
	    for(rungg=0;rungg<ffd.fileList.size();rungg++) {
	    	if (rungg!=runff) {trainStr += dataStr[rungg]; uuu += recCount[rungg];} 
	    }
	    	    
	    System.out.println(runff+". training "+fileNames[runff]+ ": training_set:"+uuu);
	    System.out.println("readData()");
	    readData();
	    System.out.println("writeTrainingData()");
	    writeTrainingData(runff);
	}//for runff
	
	eDate = new java.util.Date();
	System.out.println(((eDate.getTime()-sDate.getTime())/1000/60)+"minutes");
	return;
    }
    //####################
    private void readData()
    {
	for(fff=0;fff<bc.C_SIZE;fff++) {
	    countC[fff] = 0;
	    for(zz=0;zz<POSRANGE;zz++) {cPosC[fff][zz] = wPosC[fff][zz] = 0;}
	}
	trainStr = " "+trainStr;
	
	iii = trainStr.indexOf("<REC>");
	jjj = trainStr.indexOf("</REC>");
	while(iii>-1 && jjj>iii) {
	    
	    tmp1 = trainStr.substring(iii+5, jjj).trim();
	    trainStr = trainStr.substring(jjj+6);
	    //System.out.println(tmp1);
	    
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll("</"+bc.csTag[iii].substring(1)," ");}//for iii
	    
	    tmp2 = tmp1.trim(); //data w/ <cat_tag>
	    while (tmp2.indexOf("  ")>-1) {tmp2 = tmp2.replaceAll("  "," ");}
	    
	    words1 = tmp2.split(" ");
	    seg0.clear(); //tag list according to single words
	    for(iii=0;iii<words1.length;iii++) {
		if (bc.tagHash.containsKey(words1[iii])) {tmp3 = words1[iii];}
		else {seg0.add(tmp3);}
	    }
	    	    
	    answerL = new String[seg0.size()]; //original tag list according to single words
	    for(iii=0;iii<seg0.size();iii++) {answerL[iii] = String.valueOf(seg0.elementAt(iii));}
	    
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll(bc.csTag[iii]," ");}//for iii		
	    tmp1 = tmp1.trim(); //data w/o <cat_tag>
	    while (tmp1.indexOf("  ")>-1) {tmp1 = tmp1.replaceAll("  "," ");}
	    
	    dataL = tmp1.split(" "); //single words
	    cLen = tmp1.length();
	    wLen = dataL.length;
	    //if (dataL.length!=answerL.length) {System.out.println("-----------\n"+tmp1+"\n"+tmp2);}
	    
	    bbb = 0; //length in chars before current token, indexOf current token in the record
	    
	    for(iii=0;iii<dataL.length;iii++) {
		C_INDEX = Integer.parseInt(String.valueOf(bc.tagHash.get(answerL[iii])));
		
		countC[C_INDEX]++; //# of tokens in category C_INDEX
		//character pos
		if (iii-1>=0) {bbb += dataL[iii-1].length()+ 1;} //space
		dtmp1 = bbb * 1.0 / cLen;
		if (dtmp1<0.1) {cPosC[C_INDEX][0]++;}
		else if (dtmp1>=0.1 && dtmp1<0.2) {cPosC[C_INDEX][1]++;}
		else if (dtmp1>=0.2 && dtmp1<0.3) {cPosC[C_INDEX][2]++;}
		else if (dtmp1>=0.3 && dtmp1<0.4) {cPosC[C_INDEX][3]++;}
		else if (dtmp1>=0.4 && dtmp1<0.5) {cPosC[C_INDEX][4]++;}
		else if (dtmp1>=0.5 && dtmp1<0.6) {cPosC[C_INDEX][5]++;}
		else if (dtmp1>=0.6 && dtmp1<0.7) {cPosC[C_INDEX][6]++;}
		else if (dtmp1>=0.7 && dtmp1<0.8) {cPosC[C_INDEX][7]++;}
		else if (dtmp1>=0.8 && dtmp1<0.9) {cPosC[C_INDEX][8]++;}
		else if (dtmp1>=0.9 && dtmp1<=1.0) {cPosC[C_INDEX][9]++;}
		//token pos
		dtmp1 = iii * 1.0 / wLen;
		if (dtmp1<0.1) {wPosC[C_INDEX][0]++;}
		else if (dtmp1>=0.1 && dtmp1<0.2) {wPosC[C_INDEX][1]++;}
		else if (dtmp1>=0.2 && dtmp1<0.3) {wPosC[C_INDEX][2]++;}
		else if (dtmp1>=0.3 && dtmp1<0.4) {wPosC[C_INDEX][3]++;}
		else if (dtmp1>=0.4 && dtmp1<0.5) {wPosC[C_INDEX][4]++;}
		else if (dtmp1>=0.5 && dtmp1<0.6) {wPosC[C_INDEX][5]++;}
		else if (dtmp1>=0.6 && dtmp1<0.7) {wPosC[C_INDEX][6]++;}
		else if (dtmp1>=0.7 && dtmp1<0.8) {wPosC[C_INDEX][7]++;}
		else if (dtmp1>=0.8 && dtmp1<0.9) {wPosC[C_INDEX][8]++;}
		else if (dtmp1>=0.9 && dtmp1<=1.0) {wPosC[C_INDEX][9]++;}
	    }//for iii
	    //try {System.in.read();}
	    //catch (java.lang.Exception e) {System.out.println(e.toString()+"....^^"); }
	    
	    //next record
	    iii = trainStr.indexOf("<REC>");
	    jjj = trainStr.indexOf("</REC>");
	}//while the whole file
	
	return;
    }
    //######################
    private void writeTrainingData(int argFolderID)
    {
	try {
	    F2 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_pos");
	    F2.delete();
	    file2 = new RandomAccessFile(F2, "rw");
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		file2.writeBytes("countC["+iii+"]="+countC[iii]+"\n");
		for(jjj=0;jjj<POSRANGE;jjj++) {file2.writeBytes("wPosC["+iii+"]["+jjj+"]="+wPosC[iii][jjj]+"\n");}
		for(jjj=0;jjj<POSRANGE;jjj++) {file2.writeBytes("cPosC["+iii+"]["+jjj+"]="+cPosC[iii][jjj]+"\n");}
		file2.writeBytes("\n");
	    }
	    file2.close();
	    
	    //file3 human readable file
	    F3 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_pos_human");
	    F3.delete();
	    file3 = new RandomAccessFile(F3, "rw");
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		file3.writeBytes("countC"+bc.csTag[iii]+"="+countC[iii]+"\n");
		for(jjj=0;jjj<POSRANGE;jjj++) {file3.writeBytes("wPosC["+bc.csTag[iii]+"]["+jjj+"]="+wPosC[iii][jjj]+"\n");}
		for(jjj=0;jjj<POSRANGE;jjj++) {file3.writeBytes("cPosC["+bc.csTag[iii]+"]["+jjj+"]="+cPosC[iii][jjj]+"\n");}
		
		file3.writeBytes("\n");
	    }//for iii
	    
	    file3.close();
	    
	}//try
	catch (java.lang.Exception e) {System.out.println(e.toString()+"..2");}
	
	return;
    }
    //#########
    public static void main(String[] args)
    {
    	segTestOneCmmcTrain3 gf = new segTestOneCmmcTrain3(args[0], args[1], args[2]);//Dir name where the addTail files are
	gf.runTenFolder();
	/*
	  runTenFolder() ->
	  
	  readData() 
	      
	  writeTrainingData(runff);
	*/
	return;
    }
}
