/*
create training set for level-1 C4.5 decision tree
*/

import java.lang.*;
import java.io.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Date;
import java.text.DecimalFormat;
//##########################
class testSeg
{ 
    private basicConcepts bc;
    private double lemda = 0.5, dtmp1, dtmp2;
    private int[] countC;
    private int[][][] ttC;
    private double[] smoothedDeW, probC, smoothedDeT, smoothedDeP;
    private String dd1, dd2, dd3;
    private DecimalFormat dformat, dformat2;
    
    private double[][][][] tmdet, cmdec;
    private double[][] tmpScore11, tmpScore12, cmfdc;
    
    private double[] tmpScore2, tmpScore3, tmpScore5;//, fScore, recall_nu, recall_de, precision_nu, precision_de;
    private double[] fScore2, recall_nu2, recall_de2, precision_nu2, precision_de2;
    private int[][] confusionMatrix2;//, confusionMatrix;
    private int[] recCount;//countOri, countExt, countCor, ;
    private int[] countOri2, countExt2, countCor2;
    private String[] words1, dataL, labelL, answerL, deList, tmpWords, dataStr, fileNames;
        
    private int C_INDEX,  lTid, rTid, deid, detid, catid, iii,jjj,fff,ggg, bbb, aaa;
    private int segCount, STARTSET, ENDSET, totalWordNum;
    private int ii, jj, kk, yy,zz, mm,  nn;
    private String line, argTrainingDirName, argAbsDirName, fileStr1;
    private String testStr, tmp1, tmp12;
    private File F1,F2, F3, F5, F8;
    private RandomAccessFile file1,file2, file3, file5, file8;
    
    private Vector seg0, cmmc, cmmcCnt, tmmt, tmmtCnt;
    private Hashtable deHash;
    private Date sDate, eDate;
    private filesFromDir ffd;
    //####################
    public testSeg(String arg, String argStartID, String argEndID)
    {
	argTrainingDirName = arg;
	bc = new basicConcepts();
		
	try {
	    STARTSET = Integer.parseInt(argStartID);
	    ENDSET = Integer.parseInt(argEndID);
	}
	catch  (java.lang.Exception e) {System.out.println(e.toString()+"..startsetid"); STARTSET=0; ENDSET=0;}
	//-------------------
	
	dformat = new DecimalFormat("#.##");
	dformat2  = new DecimalFormat("#.####");
		
	countC = new int[bc.C_SIZE];
	smoothedDeW = new double[bc.C_SIZE];
	smoothedDeT = new double[bc.C_SIZE];
	smoothedDeP = new double[bc.C_SIZE];
	probC = new double[bc.C_SIZE];

	ttC = new int[bc.C_SIZE][bc.T_SIZE][bc.T_SIZE];
		
	tmpScore2 = new double[bc.C_SIZE];
	tmpScore5 = new double[bc.C_SIZE];
	
	cmmc = new Vector(); cmmcCnt = new Vector();
	//tmmt = new Vector(); tmmtCnt = new Vector();
	
	seg0 = new Vector();
		
	//countOri = new int[bc.C_SIZE]; countExt = new int[bc.C_SIZE]; 
	//fScore = new double[bc.C_SIZE]; 
	//recall_nu = new double[bc.C_SIZE]; precision_nu = new double[bc.C_SIZE];
	//recall_de = new double[bc.C_SIZE]; precision_de = new double[bc.C_SIZE];
	//countCor = new int[bc.C_SIZE]; 	confusionMatrix = new int[bc.C_SIZE][bc.C_SIZE];
	/*
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    countOri[iii] = countExt[iii] = countCor[iii] = 0;
	    fScore[iii] = recall_nu[iii] = precision_nu[iii] = recall_de[iii] = precision_de[iii] = 0;
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {confusionMatrix[iii][jjj] = 0;}
	}
	*/
	countOri2 = new int[bc.C_SIZE]; countExt2 = new int[bc.C_SIZE]; 
	fScore2 = new double[bc.C_SIZE]; 
	recall_nu2 = new double[bc.C_SIZE]; precision_nu2 = new double[bc.C_SIZE];
	recall_de2 = new double[bc.C_SIZE]; precision_de2 = new double[bc.C_SIZE];
	countCor2 = new int[bc.C_SIZE]; 	confusionMatrix2 = new int[bc.C_SIZE][bc.C_SIZE];
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    countOri2[iii] = countExt2[iii] = countCor2[iii] = 0;
	    fScore2[iii] = recall_nu2[iii] = precision_nu2[iii] = recall_de2[iii] = precision_de2[iii] = 0;
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {confusionMatrix2[iii][jjj] = 0;}
	}
    }
    //#############
    //for each String, remove all tags, punctuation
    private String tmp9;
    private String removeTagPunc(String arg)
    {
    	tmp9 = arg;
    	tmp9 = tmp9.replaceAll("</[\\S]+>"," ");
    	tmp9 = tmp9.replaceAll("<[\\S]+>"," ");
    	tmp9 = tmp9.replaceAll("[^\\w ]+"," ");
    	while(tmp9.indexOf("  ")>-1) {tmp9 = tmp9.replaceAll("  ", " ");}
    	return tmp9.trim();    	
    }
    //###############
    //single de mark segment
    String tmp10, tmp11;
    private void getCmcScores(String argS, int argSegID) 
    {
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] = 1E-20;}
	if (argSegID==0) {lTid = bc.T_SIZE; tmp10 = "<RS>";}
	else {
	    tmp10 = String.valueOf(seg0.elementAt(argSegID-1)).trim();
	    mm = tmp10.lastIndexOf(" ");
	    if (mm>-1) {tmp10 = tmp10.substring(mm+1);}
	    lTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(tmp10)))));
	}
	
	if (argSegID==seg0.size()-1) {rTid = bc.T_SIZE; tmp11 = "<RE>";}
	else {
	    tmp11 = String.valueOf(seg0.elementAt(argSegID+1)).trim();
	    mm = tmp11.indexOf(" ");
	    if (mm>-1) {tmp11 = tmp11.substring(0,mm);}
	    rTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(tmp11)))));
	}
	
	deid = Integer.parseInt(String.valueOf(deHash.get(argS)));
	detid = Integer.parseInt(String.valueOf(bc.tokenHash.get(argS)));
	//System.out.println(tmp10+" "+deList[deid]+" "+tmp11);
	
	//s3 cmdec based on max(s2[ii-1] * s2[ii+1] * cmdec[cat_m][cat_n][m][cat])
	dtmp2 = -1;
	if (argSegID==0) {
	    tmpScore11[argSegID][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))] = 100;
	}//0
	else if (argSegID==seg0.size()-1) {
	    tmpScore11[argSegID][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))] = 100;
	}
	else {
	    /*
	    for(nn=0;nn<bc.C_SIZE;nn++) {
		for(kk=0;kk<bc.C_SIZE;kk++) {
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			if ((nn==kk && mm==nn) || (nn!=kk && nn!=mm && kk!=mm && mm==Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>"))))) {
			    dtmp1 = tmpScore11[argSegID-1][nn]*tmpScore11[argSegID+1][kk]*(cmdec[nn][kk][deid][mm]+lemda);
			    if (dtmp1>tmpScore11[argSegID][mm]) {tmpScore11[argSegID][mm] = dtmp1;}
			}//if nn,mm, kk
		    }
		}
	    }//for nn
	    */
	    for(nn=0;nn<bc.C_SIZE;nn++) {
		for(kk=0;kk<bc.C_SIZE;kk++) {
		    if (nn==kk) {
			dtmp1 = tmpScore11[argSegID-1][nn]*tmpScore11[argSegID+1][kk]*(cmfdc[deid][nn]+lemda);
			if (dtmp1>tmpScore11[argSegID][nn]) {tmpScore11[argSegID][nn] = dtmp1;}
		    }
		    else { //nn!=kk
			dtmp1 = tmpScore11[argSegID-1][nn]*tmpScore11[argSegID+1][kk]*(cmfdc[deid][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))]+lemda);
			if (dtmp1>tmpScore11[argSegID][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))]) {tmpScore11[argSegID][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))] = dtmp1;}
		    }
		    
		}//for kk
	    }//for nn
	}//else
	//for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] *= probC[mm];}
	//-----------------------------
	/*
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore2[mm] = 1e-20;}
	for(mm=0;mm<bc.C_SIZE;mm++) {
	    if (tmdet[lTid][rTid][deid][mm]>0) {
		tmpScore2[mm] = (tmdet[lTid][rTid][deid][mm]+lemda)/smoothedDeT[mm];
	    }
	    else {
		if (lTid<bc.T_SIZE && rTid<bc.T_SIZE) {
		    tmpScore2[mm] = (ttC[mm][lTid][deid]+lemda)/smoothedDeT[mm]*(ttC[mm][deid][rTid]+lemda)/smoothedDeT[mm];
		}
		else if (lTid==bc.T_SIZE) {
		    tmpScore2[Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))]=1;
		    //tmpScore2[mm]=1;//lemda/smoothedDeT[mm]*(ttC[mm][deid][rTid]+lemda)/smoothedDeT[mm];
		}
		else if (rTid==bc.T_SIZE) {
		    tmpScore2[Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))]=1;
		    //tmpScore2[mm]=1;//(ttC[mm][lTid][deid]+lemda)/smoothedDeT[mm]*lemda/smoothedDeT[mm];
		}
	    }
	    //tmpScore2[mm] *= probC[mm];
	}//for mm
	//----------------
	dtmp1 = 0;
	for(mm=0;mm<bc.C_SIZE;mm++) {dtmp1 += tmpScore11[argSegID][mm]*tmpScore2[mm];}
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] = tmpScore11[argSegID][mm]*tmpScore2[mm]/dtmp1;}
	*/
	dtmp1 = 0;
	for(mm=0;mm<bc.C_SIZE;mm++) {dtmp1 += tmpScore11[argSegID][mm];}
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] = tmpScore11[argSegID][mm]/dtmp1;}
	return;
    }
    //####################
    private void runTenFolder() 
    {
	int hhh, runff,rungg, uuu, vvv;
	sDate = new java.util.Date();

	try {
	    ffd = new filesFromDir();
	    ffd.set(argTrainingDirName,"_addTail");
	    if (ffd.findFiles() && ffd.fileList.size()>0) {
		F1 = new File(String.valueOf(ffd.fileList.elementAt(0)));
		argAbsDirName = F1.getPath(); 
		argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("/"));
		//argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("\\"));
	
		dataStr = new String[ffd.fileList.size()];
		recCount = new int[ffd.fileList.size()];
		fileNames = new String[ffd.fileList.size()];
		
		for(runff=0;runff<ffd.fileList.size();runff++) {
		    F1 = new File(String.valueOf(ffd.fileList.elementAt(runff)));
		    file1 = new RandomAccessFile(F1,"r");
		    		    
		    fileNames[runff] = F1.getPath();
		    ///System.out.println(fileNames[runff]);
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("/")+1);
		    //fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("\\")+1);
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].indexOf("clean_")+6, fileNames[runff].indexOf("_labeled"));
		    
		    recCount[runff] = 0; //# of rec <REC>
		    dataStr[runff] = "";
		    if (runff>=STARTSET && runff<=ENDSET) {   
			while ((line=file1.readLine())!=null) {
			    if (!line.startsWith("<")) {continue;}
			    dataStr[runff] += "___" + line.trim();
			    if (line.equals("<REC>")) {recCount[runff]++;}
			}
		    }//if
		    file1.close();
		}//for runff
	    } //if ffd
	    else {dataStr = null;}
	}
	catch (java.lang.Exception e) {System.out.println(e.toString());}
	
	//for(runff=STARTSET;runff<ffd.fileList.size();runff++) {System.out.println(dataStr[runff].length());}

	for(runff=STARTSET;runff<=ENDSET;runff++) { 
	    testStr = ""; uuu = vvv = 0;
	    for(rungg=0;rungg<ffd.fileList.size();rungg++) {
	    	if (!fileNames[rungg].equals(fileNames[runff])) {
		    uuu += recCount[rungg];
		} 
	    	else {testStr += dataStr[rungg]; vvv+=recCount[rungg];}
	    }
	    
	    System.out.println(runff+". testing "+fileNames[runff]+ ": training_set:"+uuu+" testing_set:" + vvv);
	    
	    testStr = testStr.substring(3);
	    //System.out.println("writeTrainingData()");
	    readTrainingData(runff);
	    //System.out.println("convert()");
	    convert(runff); //
	    //System.out.println("readTestData()");
	    try {
		F8 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[runff]+"_statistics_token");
		F8.delete();
		file8 = new RandomAccessFile(F8, "rw");
	    } catch  (java.lang.Exception e) {System.out.println(e.toString()+"..runTenFolder()2");}
	    readLevelOneData(runff);
	    readTestData(runff); //statistics_files
	    try {
		file8.writeBytes("-------------------------------------\n");
		for(hhh=0;hhh<bc.C_SIZE;hhh++) {file8.writeBytes(bc.csTag[hhh]+" recall="+recall_nu2[hhh]+"/"+recall_de2[hhh]+"="+dformat.format(recall_nu2[hhh]*100.0/recall_de2[hhh])+"\tprecision="+precision_nu2[hhh]+"/"+precision_de2[hhh]+"="+dformat.format(precision_nu2[hhh]*100.0/precision_de2[hhh])+"\tfScore="+dformat.format(200*(recall_nu2[hhh]*1.0/recall_de2[hhh])*(precision_nu2[hhh]*1.0/precision_de2[hhh])/((recall_nu2[hhh]*1.0/recall_de2[hhh])+(precision_nu2[hhh]*1.0/precision_de2[hhh])))+"\n\n");}
		
		file8.close();
	    } catch  (java.lang.Exception e) {System.out.println(e.toString()+"..runTenFolder()1");}
	    System.out.println("_______________________");
	}//for runff
	
	eDate = new java.util.Date();
	System.out.println(((eDate.getTime()-sDate.getTime())/1000/60)+"minutes");
	
	return;
    }
    //##################
    private void readTrainingData(int argFolderID)
    {
	cmmc = new Vector(); cmmcCnt = new Vector();
	//tmmt = new Vector(); tmmtCnt = new Vector();
	
	totalWordNum = 0;
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    countC[iii] = 0;
	    smoothedDeW[iii] = smoothedDeT[iii] = smoothedDeP[iii] = probC[iii] = 0;
	    

	    for(jjj=0;jjj<bc.T_SIZE;jjj++) {
		for(fff=0;fff<bc.T_SIZE;fff++) {ttC[iii][jjj][fff] = 0;}
	    }
	}//for iii
	
	try {
	    F2 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+ fileNames[argFolderID]);
	    file2 = new RandomAccessFile(F2, "r");
	    //read nbc from file
	    
	    while ((line=file2.readLine())!=null) {
		//System.out.println(line);
		if (line.startsWith("countC[")) {
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    countC[iii] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		else if (line.startsWith("tt[")) {
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    tmp1 = line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")); //tid1 tid2
		    jjj = Integer.parseInt(tmp1.substring(0,tmp1.indexOf(" ")));
		    fff = Integer.parseInt(tmp1.substring(tmp1.indexOf(" ")+1));
		    ttC[iii][jjj][fff] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		//totaluniquewords=5265
		else if (line.startsWith("totaluniquewords=")) {
		    totalWordNum = Integer.parseInt(line.substring(line.lastIndexOf("=")+1));
		}
		else if (line.startsWith("deV_SIZE")) {
		    deList = new String[Integer.parseInt(line.substring(line.indexOf("=")+1).trim())];
		    //System.out.println("deList="+deList.length);
		    tmdet = new double[bc.T_SIZE+1][bc.T_SIZE+1][deList.length][bc.C_SIZE];
		    
		    for(iii=0;iii<bc.T_SIZE+1;iii++) {
			for(jjj=0;jjj<bc.T_SIZE+1;jjj++) {
			    for(fff=0;fff<deList.length;fff++) {for(ggg=0;ggg<bc.C_SIZE;ggg++) {tmdet[iii][jjj][fff][ggg] = 0;}}
			}
		    }
		    //scan file for marks M serving as delimiter, find all (cat_left M cat_right),
		    //build talbe: (cat1, cat2, m, cat, #)
		    cmdec = new double[bc.C_SIZE+1][bc.C_SIZE+1][deList.length][bc.C_SIZE];
		    for(iii=0;iii<bc.C_SIZE+1;iii++) {
			for(jjj=0;jjj<bc.C_SIZE+1;jjj++) {
			    for(fff=0;fff<deList.length;fff++) {
				for(ggg=0;ggg<bc.C_SIZE;ggg++) {
				    cmdec[iii][jjj][fff][ggg] = 0;
				}
			    }
			}
		    }
		    cmfdc = new double[deList.length][bc.C_SIZE];
		    for(fff=0;fff<deList.length;fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    cmfdc[fff][ggg] = 0;
			}
		    }
		}
		else if (line.startsWith("de[")) {
		    ii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    deList[ii] = line.substring(line.indexOf("=")+1).trim();
		}
		else if (line.startsWith("tmdet[")) {//tmdet[ ][42][3][8]=78.0
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    if (tmp1.equals(" ")) {ii = bc.T_SIZE;}
		    else {ii = Integer.parseInt(tmp1);}
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    if (tmp1.equals(" ")) {jj = bc.T_SIZE;}
		    else {jj = Integer.parseInt(tmp1);}
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    kk = Integer.parseInt(tmp1);
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    yy = Integer.parseInt(tmp1);
		    line = line.substring(nn+1);
		    
		    tmdet[ii][jj][kk][yy] = Integer.parseInt(line.substring(line.indexOf("=")+1));
		}
		else if (line.startsWith("cmdec[")) {//cmdec[ ][42][3][8]=78.0
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    if (tmp1.equals(" ")) {ii = bc.C_SIZE;}
		    else {ii = Integer.parseInt(tmp1);}
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    if (tmp1.equals(" ")) {jj = bc.C_SIZE;}
		    else {jj = Integer.parseInt(tmp1);}
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    kk = Integer.parseInt(tmp1);
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    yy = Integer.parseInt(tmp1);
		    line = line.substring(nn+1);
		    
		    cmdec[ii][jj][kk][yy] = Integer.parseInt(line.substring(line.indexOf("=")+1));
		}
		else if (line.startsWith("cmmc (")) { //cmmc (, " <A>) <AU> <TI> <DE> 3
		    kk = line.lastIndexOf(" ");
		    cmmc.add(line.substring(5,kk));
		    cmmcCnt.add(line.substring(kk+1));
		}
		/*
		else if (line.startsWith("tmmt (")) { //cmmc (, " <A>) <AU> <TI> <DE> 3
		    kk = line.lastIndexOf(" ");
		    tmmt.add(line.substring(5,kk));
		    tmmtCnt.add(line.substring(kk+1));
		}
		*/
	    }//while
	    file2.close();
	    /*
	    for(iii=0;iii<bc.C_SIZE+1;iii++) {
		for(jjj=0;jjj<bc.C_SIZE+1;jjj++) {
		    for(fff=0;fff<deList.length;fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    cmfdc[fff][ggg] += cmdec[iii][jjj][fff][ggg];
			}
		    }
		}
	    }
	    */
	    for(fff=0;fff<deList.length;fff++) {
		for(ggg=0;ggg<bc.C_SIZE;ggg++) {
		    for(iii=0;iii<bc.C_SIZE+1;iii++) {
			for(jjj=0;jjj<bc.C_SIZE+1;jjj++) {
			    if ((iii==jjj && iii==ggg) || (iii!=jjj && bc.csTag[ggg].equals("<DE>"))) {
				cmfdc[fff][ggg] += cmdec[iii][jjj][fff][ggg];
			    }
			}
		    }
		}
	    }
	    dtmp1 = 0;
	    for(iii=0;iii<bc.C_SIZE;iii++) {dtmp1 += countC[iii];}
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		probC[iii] = (countC[iii]+lemda)/(dtmp1+lemda*bc.C_SIZE);
		//System.out.println("probC["+bc.csTag[iii]+"] "+probC[iii]);
	    }
	    //normalize probC
	    dtmp1 = 0;
	    for(iii=0;iii<bc.C_SIZE;iii++) {dtmp1 += probC[iii];}
	    for(iii=0;iii<bc.C_SIZE;iii++) {probC[iii] = probC[iii]/dtmp1;}
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		smoothedDeW[iii] = countC[iii] + lemda * totalWordNum;
		smoothedDeT[iii] = countC[iii] + lemda * totalWordNum;//bc.T_SIZE;
		smoothedDeP[iii] = countC[iii] + lemda * totalWordNum;//bc.P_SIZE;
		//System.out.println(bc.csTag[iii]+" "+smoothedDe[iii]);
	    }
	}//try
	catch (java.lang.Exception e) {System.out.println(e.toString()+"..2");}
	
	return;
    }
    //####################
    private void convert(int argFolderID) //training data structure -> testing data structure
    {
	//System.out.println(deList.length);
	deHash = new Hashtable(deList.length);
	for(jj=0;jj<deList.length;jj++) {deHash.put(deList[jj],String.valueOf(jj));}
	
	return;
    }
    //#############
    //get features from every record, save to _features file
    private String rawData, tmp2, tmp3, tmp4, tmp5, tmp14;
    private boolean found2;
    private double asdf;
    private int asdf2;
    private void readTestData(int argFolderID)
    {
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    //countOri[iii] = countExt[iii] = countCor[iii] = 0;
	    countOri2[iii] = countExt2[iii] = countCor2[iii] = 0;
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {confusionMatrix2[iii][jjj] = 0;}// confusionMatrix[iii][jjj] = 0;}
	}
    	try {
	    F5 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_result_w_scores");
	    F5.delete();
	    file5 = new RandomAccessFile(F5, "rw");
	} catch (java.lang.Exception e) {System.out.println(e.toString()+"..#");}
    	
	segCount = 0;
	testStr += " ";
	iii = testStr.indexOf("<REC>");
	jjj = testStr.indexOf("</REC>");
	while(iii>-1 && jjj>iii) {
	    tmp1 = testStr.substring(iii+5, jjj).trim();
	    while (tmp1.startsWith("___")) {tmp1 = tmp1.substring(3);}
	    while (tmp1.endsWith("___")) {tmp1 = tmp1.substring(0, tmp1.length()-3);}
	    testStr = testStr.substring(jjj+6);
	    //System.out.println(tmp1);
	    
	    tmp1 = tmp1.replaceAll("___", "");
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll("</"+bc.csTag[iii].substring(1)," ");}//for iii
	    
	    tmp2 = tmp1.trim(); //data w/ <cat_tag>
	    while (tmp2.indexOf("  ")>-1) {tmp2 = tmp2.replaceAll("  "," ");}
	    
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll(bc.csTag[iii]," ");}//for iii		
	    tmp1 = tmp1.trim(); //data w/o <cat_tag>
	    while (tmp1.indexOf("  ")>-1) {tmp1 = tmp1.replaceAll("  "," ");}
	    rawData = tmp1 +" ";//tmp2: <cat> seg <cat> seg <cat> seg tmp1: seg seg seg
	    dataL = tmp1.split(" "); //single words
	    
	    //creat labelL
	    words1 = tmp2.split(" ");
	    seg0.clear(); //tag list according to single words
	    for(iii=0;iii<words1.length;iii++) {
		if (bc.tagHash.containsKey(words1[iii])) {tmp3 = words1[iii];}
		else {seg0.add(tmp3);}
	    }
	    
	    tmpScore12 = new double[seg0.size()][bc.C_SIZE];
	    labelL = new String[seg0.size()]; //computed tag list according to single words
	    answerL = new String[seg0.size()]; //original tag list according to single words
	    for(iii=0;iii<seg0.size();iii++) {answerL[iii] = String.valueOf(seg0.elementAt(iii));}
	    //create initial segments, delimiter based on training results
	    seg0.clear();
	    iii = rawData.indexOf(" ");
	    tmp4 = "";
	    tmp5 = ""; //connectable elements
	    while (iii>0) {
		tmp2 = rawData.substring(0,iii).trim(); //left most string
		rawData = rawData.substring(iii+1);

		if (deHash.containsKey(tmp2)) {
		    if (!tmp5.equals("")) {
			seg0.add(tmp5.trim()); tmp5 = "";
		    }
		    tmp4 += tmp2+" ";
		}
		else {
		    if (!tmp4.equals("")) {seg0.add(tmp4.trim()); tmp4 = "";}
		    tmp5 += tmp2 + " ";
		}
		
		iii = rawData.indexOf(" ");
	    }//while (iii>0)
	    if (!tmp5.equals("")) {
		seg0.add(tmp5.trim()); tmp5 = "";
	    }
	    if (!tmp4.equals("")) {seg0.add(tmp4.trim()); tmp4 = "";}
	    
	    tmpScore11 = new double[seg0.size()][bc.C_SIZE];
	    for(iii=0;iii<seg0.size();iii++) {for(jjj=0;jjj<bc.C_SIZE;jjj++) {
		tmpScore11[iii][jjj] = 1;}
	    }//for iii
	    //System.out.println("---------------");
	    //for(iii=0;iii<seg0.size();iii++) {System.out.println("seg["+iii+"]="+String.valueOf(seg0.elementAt(iii)));}
	    //System.out.println("---------------\n");
	    
	    for(iii=0;iii<seg0.size();iii++) {
		tmp4 = String.valueOf(seg0.elementAt(iii));
		tmpWords = tmp4.split(" ");
		found2 = false;
		for(ggg=0;ggg<tmpWords.length;ggg++) {
		    if (deHash.containsKey(tmpWords[ggg])) {found2 = true;break;}
		}
		if (!found2) {//non SD segment
		    //fill tmpScore11 with values from tmpScore10
		    for(jjj=0;jjj<bc.C_SIZE-1;jjj++) {
			tmpScore11[iii][jjj] = tmpScore10[segCount][jjj];
		    }
		    tmpScore11[iii][bc.C_SIZE-1] = 0;
		    segCount++;
		    //getStrScores(tmp4, iii);
		}
	    }//for iii
	    
	    for(iii=0;iii<seg0.size();iii++) {
		tmp4 = String.valueOf(seg0.elementAt(iii));
		tmpWords = tmp4.split(" ");
		found2 = false;
		for(ggg=0;ggg<tmpWords.length;ggg++) {
		    if (deHash.containsKey(tmpWords[ggg])) {found2 = true;break;}
		}
		if (found2) {//SD segment
		    if (tmp4.indexOf(" ")<0) {
			getCmcScores(tmp4, iii);
			//System.out.println("---------------\n"+String.valueOf(seg0.elementAt(iii)));
			//for(jjj=0;jjj<bc.C_SIZE;jjj++) {System.out.println(bc.csTag[jjj]+" "+tmpScore11[iii][jjj]);}
		    }
		    else {
			getCmmcScores(tmp4,iii);
			//System.out.println("---------------\n"+String.valueOf(seg0.elementAt(iii)));
			//for(jjj=0;jjj<bc.C_SIZE;jjj++) {System.out.println(bc.csTag[jjj]+" "+tmpScore11[iii][jjj]);}
		    }
		}
	    }//for iii
	    /*
	    for(iii=0;iii<seg0.size();iii++) {
		System.out.println("---------------\n"+String.valueOf(seg0.elementAt(iii)));
		for(jjj=0;jjj<bc.C_SIZE;jjj++) {System.out.println(bc.csTag[jjj]+" "+tmpScore11[iii][jjj]);}
	    }
	    */  
	    //assign seg0 scores to dataL scores
	    fff = -1;
	    for(iii=0;iii<seg0.size();iii++) {
		tmp4 = String.valueOf(seg0.elementAt(iii));
		tmpWords = tmp4.split(" ");
		for(jjj=0;jjj<tmpWords.length;jjj++) {
		    fff++;
		    //if (!dataL[fff].equals(tmpWords[jjj])) {System.out.println(dataL[fff]+" / "+tmpWords[jjj]);}
		    for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			tmpScore12[fff][ggg] = tmpScore11[iii][ggg];
		    }
		}
	    }
	    
	    
	    //compute R and P, single word based
	    for(iii=0;iii<dataL.length;iii++) {
	        //if (deHash.containsKey(dataL[iii])) {continue;}
		dtmp1 = -java.lang.Double.MAX_VALUE; fff=-1;
		for(jjj=0;jjj<bc.C_SIZE;jjj++) {
		    if (tmpScore12[iii][jjj]>dtmp1) {dtmp1 = tmpScore12[iii][jjj]; fff = jjj;}
		}//for jjj
		labelL[iii] = bc.csTag[fff];
		countExt2[fff]++;
		countOri2[Integer.parseInt(String.valueOf(bc.tagHash.get(answerL[iii])))]++;
		if (labelL[iii].equals(answerL[iii])) {countCor2[Integer.parseInt(String.valueOf(bc.tagHash.get(answerL[iii])))]++;}
		confusionMatrix2[Integer.parseInt(String.valueOf(bc.tagHash.get(answerL[iii])))][fff]++;
	    }//for iii
	    //-----------------------
	    //write errors, scores to files.
	    try {
		file5.writeBytes("\n********************\n");
		for(iii=0;iii<dataL.length;iii++) {
		    file5.writeBytes(" "+dataL[iii]);
		    if (!labelL[iii].equals(answerL[iii])) {file5.writeBytes("/"+labelL[iii]);}
		}//for iii
		file5.writeBytes("\n");
		/*
		for(iii=0;iii<seg0.size();iii++) {
		    file5.writeBytes("-------------\n"+String.valueOf(seg0.elementAt(iii))+"\n");
		    for(jjj=0;jjj<bc.C_SIZE;jjj++) {
			file5.writeBytes(bc.csTag[jjj]+" s12:"+ tmpScore11[iii][jjj]+"\n");
		    }
		}//for iii
		*/
		for(iii=0;iii<dataL.length;iii++) {
		    if (!labelL[iii].equals(answerL[iii])) {
			file5.writeBytes("-------------\n");
			file5.writeBytes(dataL[iii]+" should be:"+answerL[iii]+" but:"+labelL[iii]+"\n");
			for(jjj=0;jjj<bc.C_SIZE;jjj++) {
			    file5.writeBytes(bc.csTag[jjj]+" s12:"+ dformat2.format(tmpScore12[iii][jjj])+"\n");
			    //file5.writeBytes(bc.csTag[jjj]+" s12:"+ tmpScore12[iii][jjj]+"\n");
			}
		    }
		}//for iii
		
		file5.writeBytes("\n");
	    } catch (java.lang.Exception e) {System.out.println(e.toString()+"..@");}
	    
	    //next record
	    iii = testStr.indexOf("<REC>");
	    jjj = testStr.indexOf("</REC>");
	}//while the whole file
	System.out.println(tmpScore10.length+" "+segCount);
	//System.out.println("     train#   Ori#   Ext#   Cor#   Recall   Precision   fScore");
	/*
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    dtmp1 = countCor[iii]*1.0/countOri[iii]*100; //recall
	    dd1 = dformat.format(dtmp1); //recall
	    dtmp2 = countCor[iii]*1.0/countExt[iii]*100; //precision
	    dd2 = dformat.format(dtmp2); //precision
	    dd3 = dformat.format(2*dtmp1*dtmp2/(dtmp1+dtmp2)); //fScore = 2*R*P/(R+P)
	    
	    recall_nu[iii] += countCor[iii]; //sum of recalls
	    recall_de[iii] += countOri[iii]; //sum of recalls
	    precision_nu[iii] += countCor[iii]; //sum of precisions
	    precision_de[iii] += countExt[iii]; //sum of precisions
	}//for iii
	*/
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    /*
	    dtmp1 = countCor2[iii]*1.0/countOri2[iii]*100; //recall
	    dd1 = dformat.format(dtmp1); //recall
	    dtmp2 = countCor2[iii]*1.0/countExt2[iii]*100; //precision
	    dd2 = dformat.format(dtmp2); //precision
	    dd3 = dformat.format(2*dtmp1*dtmp2/(dtmp1+dtmp2)); //fScore = 2*R*P/(R+P)
	    */
	    recall_nu2[iii] = countCor2[iii]; //sum of recalls
	    recall_de2[iii] = countOri2[iii]; //sum of recalls
	    precision_nu2[iii] = countCor2[iii]; //sum of precisions
	    precision_de2[iii] = countExt2[iii]; //sum of precisions
	}//for iii
	
	try {
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {file8.writeBytes("\t"+bc.csTag[jjj]);}
	    file8.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		file8.writeBytes(bc.csTag[iii]+"\t");
		for(jjj=0;jjj<bc.C_SIZE;jjj++) {
		    if (confusionMatrix2[iii][jjj]>0) {file8.writeBytes(String.valueOf(confusionMatrix2[iii][jjj]));}
		    else  {file8.writeBytes(" ");}
		    file8.writeBytes("\t");
		}
		file8.writeBytes("\n");
	    }//for iii
	    file8.writeBytes("\n\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
	    	dtmp1 = countCor2[iii]*1.0/countOri2[iii]*100; //recall
	        dd1 = dformat.format(dtmp1); //recall
	        dtmp2 = countCor2[iii]*1.0/countExt2[iii]*100; //precision
	        dd2 = dformat.format(dtmp2); //precision
	        dd3 = dformat.format(2*dtmp1*dtmp2/(dtmp1+dtmp2)); //fScore = 2*R*P/(R+P)
		file8.writeBytes(fileNames[argFolderID]+" "+bc.csTag[iii] +"\ttrain#="+java.lang.Math.round(countC[iii])+"\tOri#="+countOri2[iii]+"\tExt#="+  countExt2[iii] +"\tCor#="+countCor2[iii]+"\t");
		file8.writeBytes("R="+dd1+"\tP="+dd2+"\tf="+dd3+"\n\n");
	    }//for iii
	   
	    file5.close(); 
	}
	catch (java.lang.Exception e) {System.out.println(e.toString()+"..#");}
	return;
    }
    //################
    String tmp6, ltT, ltC, rtT, rtC;
    int vv;
    private void getCmmcScores(String argS, int argSegID) 
    {
	if (argSegID==0) {ltT = ltC = "empty";}
	else {
	    tmp10 = String.valueOf(seg0.elementAt(argSegID-1)).trim();
	    mm = tmp10.lastIndexOf(" ");
	    if (mm>-1) {tmp10 = tmp10.substring(mm+1);}
	    ltT = String.valueOf(bc.getTokenType(tmp10));
	}
	
	if (argSegID==seg0.size()-1) {rtT = rtC = "empty";}
	else {
	    tmp10 = String.valueOf(seg0.elementAt(argSegID+1)).trim();
	    mm = tmp10.indexOf(" ");
	    if (mm>-1) {tmp10 = tmp10.substring(0,mm);}
	    rtT = String.valueOf(bc.getTokenType(tmp10));
	}
	
	//look for argS pattern in tmmt	
	tmp10 = "("+argS+") "+ltT+" "+rtT+" "; //(. ,) A U
	tmp11 = "("+argS+") ";
	//System.out.println("--------\n"+tmp10);
		
	//look for argS pattern in cmmc
	tmp10 = "("+argS+") "; //(. ,) 
	//s4: # of exact match, s5: # of relaxed match
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore5[mm] = lemda;}
	
	for(mm=0;mm<cmmc.size();mm++) {
	    tmp12 = String.valueOf(cmmc.elementAt(mm)); //(. ,) <AU> <JN> <DE>
	    //System.out.println(tmp12);
	    nn = Integer.parseInt(String.valueOf(bc.tagHash.get(tmp12.substring(tmp12.lastIndexOf(" ")+1))));
	    
	    if (tmp12.startsWith(tmp10)) {//(. ,) relaxed condition
		tmpScore5[nn] += Integer.parseInt(String.valueOf(cmmcCnt.elementAt(mm)));
	    }
	}
	//cmmc scores
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] = 1e-20;}
	
	tmp10 = "("+argS+") "; //(. ,) 
	dtmp2 = -1;
	if (argSegID==0) {
	    tmpScore11[argSegID][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))] = 100;
	}//0
	else if (argSegID==seg0.size()-1) {
	    tmpScore11[argSegID][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))] = 100;
	}
	else {
	    for(nn=0;nn<bc.C_SIZE;nn++) {
		for(kk=0;kk<bc.C_SIZE;kk++) {
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			if ((nn==kk && mm==nn) || (nn!=kk && nn!=mm && kk!=mm && mm==Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>"))))) {
			    
			    dtmp1 = tmpScore11[argSegID-1][nn]*tmpScore11[argSegID+1][kk]*tmpScore5[mm];
			    if (dtmp1>dtmp2) {
				dtmp2 = dtmp1;
				tmpScore11[argSegID][mm] = dtmp1;
			    }
			}//if nn,mm, kk
		    }
		}
	    }
	}
	
	dtmp1 = 0;
	for(mm=0;mm<bc.C_SIZE;mm++) {dtmp1 += tmpScore11[argSegID][mm];}
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] = tmpScore11[argSegID][mm]/dtmp1;}
	
	return;
    }
    //###############
    private double[][] tmpScore10;
    private void readLevelOneData(int argFolderID)
    {
	try {
	    F2 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_levelone");
	    file2 = new RandomAccessFile(F2, "r");
	    jjj = 0;
	    while ((line=file2.readLine())!=null) {
		iii = line.indexOf("|");
		if (iii>0 && line.lastIndexOf("|")>iii) {jjj++;}
	    }
	    file2.close();
	    System.out.println(argFolderID+" "+fileNames[argFolderID]+"_levelone = "+jjj);
	    
	    tmpScore10 = new double[jjj][bc.C_SIZE-1];
	    file2 = new RandomAccessFile(F2, "r");
	    jjj = -1;
	    while ((line=file2.readLine())!=null) {
		iii = line.indexOf("|");
		if (iii>0 && line.lastIndexOf("|")>iii) {
		    jjj++;
		    line = line.substring(iii+1);
		    //System.out.println(line);
		    words1 = line.split("\\|");
		    if (words1.length!=bc.C_SIZE-1) {System.out.println("col size != C_SIZE-1"); file2.close(); return;}
		    
		    for(fff=0;fff<words1.length;fff++) {tmpScore10[jjj][fff] = Double.parseDouble(words1[fff]);}
		}
	    }
	    file2.close();
	    System.out.println(argFolderID+" "+fileNames[argFolderID]+"_levelone = "+tmpScore10.length);
	} catch (java.lang.Exception e) {System.out.println(e.toString()+"..#");}
	return;
    }
    public static void main(String[] args)
    {
    	testSeg gf = new testSeg(args[0], args[1], args[2]);//Dir name where the addTail files are
	gf.runTenFolder();
	/*
	  runTenFolder() ->
	  
	  readTrainingData(runff);
	      
	  convert(); 
	  
	  readLevelOneData(runff);
	  
	  readTestData(runff) ->
	  
		  getCmcScores()
 
		  getCmmcScore()
		  
     	 */
	return;
    }
}
