/*

*/

import java.lang.*;
import java.io.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Date;
import java.text.DecimalFormat;
//##########################
class computePR
{ 
    private basicConcepts bc;
    
    private String dd1, dd2, dd3;
    private DecimalFormat dformat, dformat2;
    
    private double[] countOri, countExt, countCor;    
    
    private int ii, jj, kk, nn, iii;
    private double dtmp1, dtmp2, dtmp3;
    private String line, argTrainingDirName, argAbsDirName;
    private String tmp1, tmp2, tmp3, tmp4, tmp5;
    private File F1,F2, F3, F4, F5, F6, F7, F8;
    private RandomAccessFile file1,file2, file3, file4, file5, file6, file7, file8;
    
    private filesFromDir ffd;
    //####################
    public computePR(String arg)
    {
	argTrainingDirName = arg;
	bc = new basicConcepts();
	
	dformat = new DecimalFormat("#.##");
	dformat2  = new DecimalFormat("#.####");
		
	countOri = new double[bc.C_SIZE]; countExt = new double[bc.C_SIZE]; 
	countCor = new double[bc.C_SIZE];
	
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    countOri[iii] = countExt[iii] = countCor[iii] = 0;
	}
    }
    //########
    private void runTenFolder() 
    {
	try {
	    ffd = new filesFromDir();
	    ffd.set(argTrainingDirName,"_statistics_token");
	    if (ffd.findFiles() && ffd.fileList.size()>0) {
		F1 = new File(String.valueOf(ffd.fileList.elementAt(0)));
		argAbsDirName = F1.getPath();
		tmp1 = argAbsDirName.substring(argAbsDirName.lastIndexOf("/")+1);
		//tmp1 = argAbsDirName.substring(argAbsDirName.lastIndexOf("\\")+1);
		if (tmp1.length()<=31) {return;}
		argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("/"));
		//argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("\\"));
		F8 = new File(argAbsDirName,argTrainingDirName+"_nbc_statistics_token_all");
		F8.delete();
		file8 = new RandomAccessFile(F8, "rw");
		//set_test_1_nbc_statistics_token length()==31
		for(nn=0;nn<ffd.fileList.size();nn++) {
		    F1 = new File(String.valueOf(ffd.fileList.elementAt(nn)));
		    argAbsDirName = F1.getPath();
		    tmp1 = argAbsDirName.substring(argAbsDirName.lastIndexOf("/")+1);
		    //tmp1 = argAbsDirName.substring(argAbsDirName.lastIndexOf("\\")+1);
		    if (tmp1.length()<=31) {continue;}
		    if (tmp1.indexOf("_hybrid_")>-1) {continue;}
		    argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("/"));
		    //argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("\\"));
		    System.out.println(tmp1);
		    file1 = new RandomAccessFile(F1,"r");
		    		    
		    while ((line=file1.readLine())!=null) {
			if (line.startsWith("<") && line.indexOf("> recall")==3) {
			    line = line.trim();
			    tmp1 = line.substring(0,4);// <tag>
			    if (!bc.tagHash.containsKey(tmp1)) {System.out.println("!__"+line); continue;}
			    ii = Integer.parseInt(String.valueOf(bc.tagHash.get(tmp1))); //<tag> id
			    
			    jj = line.indexOf("recall="); //recall=1.0/2.0=
			    line = line.substring(jj+7);
			    jj = line.indexOf("=");
			    kk = line.indexOf("/");
			    countCor[ii] += Double.parseDouble(line.substring(0,kk));
			    countOri[ii] += Double.parseDouble(line.substring(kk+1,jj));
			    
			    jj = line.indexOf("precision="); //precision=1.0/2.0=
			    line = line.substring(jj+10); //1.0/2.0=
			    jj = line.indexOf("=");
			    kk = line.indexOf("/");
			    countExt[ii] += Double.parseDouble(line.substring(kk+1,jj));
			}//if
			else if (line!=null && !line.equals("")) {file8.writeBytes(line+"\n");}
		    }
		    file8.writeBytes("---------------------------------\n\n");
		    file1.close();
		} //for nn
	    }//if ffd
	}
	catch (java.lang.Exception e) {System.out.println("@.."+e.toString());}
	
	try {
	    file8.writeBytes("-------------------------------------\n");
	    for(ii=0;ii<bc.C_SIZE;ii++) {
		file8.writeBytes(bc.csTag[ii]+" recall="+countCor[ii]+"/"+countOri[ii]+"="+dformat.format(countCor[ii]*100/countOri[ii]));
		file8.writeBytes("\tprecision="+countCor[ii]+"/"+countExt[ii]+"="+dformat.format(countCor[ii]*100/countExt[ii]));
		file8.writeBytes("\tfScore="+dformat.format(200*countCor[ii]/(countExt[ii]+countOri[ii])));
		file8.writeBytes("\n\n");
	    }
	    file8.close();
	} catch  (java.lang.Exception e) {System.out.println(e.toString()+"..runTenFolder()1");}
	
	return;
    }
//####################
    public static void main(String[] args)
    {
    	computePR gf = new computePR(args[0]);//Dir name where the addTail files are
	gf.runTenFolder();
	
	return;
    }
}
